'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

// copied from official index.js

var toString16 = function toString16(userIdOrNumber, length) {
  var hexOrId = userIdOrNumber.toString(16);
  return hexOrId.length > length ? hexOrId.slice(hexOrId.length - length) : '0'.repeat(length - hexOrId.length) + hexOrId;
};

var map = new Map();

var getIdGenerator = function getIdGenerator(userId) {
  if (map.has(userId)) {
    return map.get(userId);
  }

  var counter = Math.floor(16777215 * Math.random());

  var generate = function generate() {
    var t = Math.floor(Date.now() / 1e3);

    if ((counter += 1) > 16777215) {
      counter = 0;
    }

    return toString16(t, 8) + toString16(userId, 6) + toString16(0, 4) + toString16(counter, 6);
  };

  map.set(userId, generate);
  return generate;
};

var generateId = function generateId(userId) {
  var generator = getIdGenerator(userId);
  return generator();
};

exports.generateId = generateId;
//# sourceMappingURL=id.js.map
