'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _rollupPluginBabelHelpers = require('../../_virtual/_rollupPluginBabelHelpers.js');
var env = require('../common/env.js');

var fetch = env.isBrowser() ? globalThis.fetch.bind(window) : require('node-fetch');
var DefaultHttpClient = /*#__PURE__*/function () {
  function DefaultHttpClient() {
    var fetchFn = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : fetch;

    _rollupPluginBabelHelpers.classCallCheck(this, DefaultHttpClient);

    _rollupPluginBabelHelpers.defineProperty(this, "fetchFn", void 0);

    this.fetchFn = fetchFn;
  }

  _rollupPluginBabelHelpers.createClass(DefaultHttpClient, [{
    key: "get",
    value: function () {
      var _get = _rollupPluginBabelHelpers.asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(url) {
        var options,
            result,
            _args = arguments;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                options = _args.length > 1 && _args[1] !== undefined ? _args[1] : {};
                _context.next = 3;
                return this.fetchFn(url, options);

              case 3:
                result = _context.sent;
                _context.next = 6;
                return result.json();

              case 6:
                return _context.abrupt("return", _context.sent);

              case 7:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function get(_x) {
        return _get.apply(this, arguments);
      }

      return get;
    }()
  }]);

  return DefaultHttpClient;
}();

exports.DefaultHttpClient = DefaultHttpClient;
exports.fetch = fetch;
//# sourceMappingURL=http-client.js.map
