'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _rollupPluginBabelHelpers = require('../../_virtual/_rollupPluginBabelHelpers.js');
var httpClient = require('./http-client.js');

var baseURL = 'https://scrapbox.io/api';
var isObject = function isObject(data) {
  return _rollupPluginBabelHelpers['typeof'](data) === 'object' && data !== null;
};
var isNotLoggedInError = function isNotLoggedInError(data) {
  return isObject(data) && data['name'] === 'NotLoggedInError';
};
var RestApiClient = /*#__PURE__*/function () {
  function RestApiClient(token) {
    var httpClient$1 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : new httpClient.DefaultHttpClient();

    _rollupPluginBabelHelpers.classCallCheck(this, RestApiClient);

    _rollupPluginBabelHelpers.defineProperty(this, "token", void 0);

    _rollupPluginBabelHelpers.defineProperty(this, "httpClient", void 0);

    this.token = token;
    this.httpClient = httpClient$1;
  }

  _rollupPluginBabelHelpers.createClass(RestApiClient, [{
    key: "getPage",
    value: function () {
      var _getPage = _rollupPluginBabelHelpers.asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(projectName, pageName) {
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                return _context.abrupt("return", this.request("".concat(baseURL, "/pages/").concat(encodeURIComponent(projectName), "/").concat(encodeURIComponent(pageName), "?followRename=true")));

              case 1:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function getPage(_x, _x2) {
        return _getPage.apply(this, arguments);
      }

      return getPage;
    }()
  }, {
    key: "getProject",
    value: function () {
      var _getProject = _rollupPluginBabelHelpers.asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(projectName) {
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                return _context2.abrupt("return", this.request("".concat(baseURL, "/projects/").concat(encodeURIComponent(projectName))));

              case 1:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function getProject(_x3) {
        return _getProject.apply(this, arguments);
      }

      return getProject;
    }()
  }, {
    key: "getProjects",
    value: function () {
      var _getProjects = _rollupPluginBabelHelpers.asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3() {
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                return _context3.abrupt("return", this.request("".concat(baseURL, "/projects")));

              case 1:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function getProjects() {
        return _getProjects.apply(this, arguments);
      }

      return getProjects;
    }()
  }, {
    key: "getMe",
    value: function () {
      var _getMe = _rollupPluginBabelHelpers.asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4() {
        return regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                return _context4.abrupt("return", this.request("".concat(baseURL, "/users/me")));

              case 1:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function getMe() {
        return _getMe.apply(this, arguments);
      }

      return getMe;
    }()
  }, {
    key: "request",
    value: function () {
      var _request = _rollupPluginBabelHelpers.asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(url) {
        var result;
        return regeneratorRuntime.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                _context5.next = 2;
                return this.httpClient.get(url, {
                  headers: {
                    Cookie: "connect.sid=".concat(this.token)
                  }
                });

              case 2:
                result = _context5.sent;

                if (!isNotLoggedInError(result)) {
                  _context5.next = 5;
                  break;
                }

                throw new Error('NotLoggedInError');

              case 5:
                return _context5.abrupt("return", result);

              case 6:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function request(_x4) {
        return _request.apply(this, arguments);
      }

      return request;
    }()
  }]);

  return RestApiClient;
}();

exports.RestApiClient = RestApiClient;
exports.isNotLoggedInError = isNotLoggedInError;
exports.isObject = isObject;
//# sourceMappingURL=rest-api-client.js.map
