'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _rollupPluginBabelHelpers = require('../_virtual/_rollupPluginBabelHelpers.js');
var restApiClient = require('./rest-api-client/rest-api-client.js');
var websocketClient = require('./websocket-clinet/websocket-client.js');

var ScrapboxClient = /*#__PURE__*/function () {
  function ScrapboxClient() {
    var token = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
    var apiClient = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : new restApiClient.RestApiClient(token);
    var websocketClient$1 = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : new websocketClient.WebsocketClient({
      token: token
    });

    _rollupPluginBabelHelpers.classCallCheck(this, ScrapboxClient);

    _rollupPluginBabelHelpers.defineProperty(this, "apiClient", void 0);

    _rollupPluginBabelHelpers.defineProperty(this, "websocketClient", void 0);

    this.apiClient = apiClient;
    this.websocketClient = websocketClient$1;
  }

  _rollupPluginBabelHelpers.createClass(ScrapboxClient, [{
    key: "getPage",
    value: function () {
      var _getPage = _rollupPluginBabelHelpers.asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(projectName, pageName) {
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                return _context.abrupt("return", this.apiClient.getPage(projectName, pageName));

              case 1:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function getPage(_x, _x2) {
        return _getPage.apply(this, arguments);
      }

      return getPage;
    }()
  }, {
    key: "changeLine",
    value: function () {
      var _changeLine = _rollupPluginBabelHelpers.asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(projectName, pageName, change) {
        var project, _yield$this$getPageId, pageId, commitId;

        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return this.getProject(projectName);

              case 2:
                project = _context2.sent;
                _context2.next = 5;
                return this.getPageIdAndCommitId(projectName, pageName);

              case 5:
                _yield$this$getPageId = _context2.sent;
                pageId = _yield$this$getPageId.pageId;
                commitId = _yield$this$getPageId.commitId;
                return _context2.abrupt("return", this.commit({
                  changes: Array.isArray(change) ? change : [change],
                  projectId: project.id,
                  pageId: pageId,
                  commitId: commitId
                }));

              case 9:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function changeLine(_x3, _x4, _x5) {
        return _changeLine.apply(this, arguments);
      }

      return changeLine;
    }()
  }, {
    key: "getUser",
    value: function () {
      var _getUser = _rollupPluginBabelHelpers.asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3() {
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return this.apiClient.getMe();

              case 2:
                return _context3.abrupt("return", _context3.sent);

              case 3:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function getUser() {
        return _getUser.apply(this, arguments);
      }

      return getUser;
    }()
  }, {
    key: "getProject",
    value: function () {
      var _getProject = _rollupPluginBabelHelpers.asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(projectName) {
        return regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _context4.next = 2;
                return this.apiClient.getProject(projectName);

              case 2:
                return _context4.abrupt("return", _context4.sent);

              case 3:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function getProject(_x6) {
        return _getProject.apply(this, arguments);
      }

      return getProject;
    }()
  }, {
    key: "getPageIdAndCommitId",
    value: function () {
      var _getPageIdAndCommitId = _rollupPluginBabelHelpers.asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(projectName, pageName) {
        var page;
        return regeneratorRuntime.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                _context5.next = 2;
                return this.apiClient.getPage(projectName, pageName);

              case 2:
                page = _context5.sent;
                return _context5.abrupt("return", {
                  pageId: page.id,
                  commitId: page.commitId
                });

              case 4:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function getPageIdAndCommitId(_x7, _x8) {
        return _getPageIdAndCommitId.apply(this, arguments);
      }

      return getPageIdAndCommitId;
    }()
  }, {
    key: "commit",
    value: function () {
      var _commit = _rollupPluginBabelHelpers.asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6(param) {
        var user;
        return regeneratorRuntime.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                _context6.next = 2;
                return this.getUser();

              case 2:
                user = _context6.sent;
                _context6.next = 5;
                return this.websocketClient.join({
                  projectId: param.projectId,
                  pageId: param.pageId
                });

              case 5:
                return _context6.abrupt("return", this.websocketClient.commit({
                  userId: user.id,
                  projectId: param.projectId,
                  pageId: param.pageId,
                  parentId: param.commitId,
                  changes: param.changes
                }));

              case 6:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function commit(_x9) {
        return _commit.apply(this, arguments);
      }

      return commit;
    }()
  }]);

  return ScrapboxClient;
}();

exports.ScrapboxClient = ScrapboxClient;
//# sourceMappingURL=scrapbox-client.js.map
