'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _rollupPluginBabelHelpers = require('../_virtual/_rollupPluginBabelHelpers.js');
var rxjs = require('rxjs');
var operators = require('rxjs/operators');
var util = require('./internal/util.js');

var UserScriptApi = /*#__PURE__*/function () {
  function UserScriptApi() {
    _rollupPluginBabelHelpers.classCallCheck(this, UserScriptApi);
  }

  _rollupPluginBabelHelpers.createClass(UserScriptApi, null, [{
    key: "data",
    get: function get() {
      if (!util.isScrapboxReady()) {
        throw new Error('window.scrapbox is not set');
      }

      return window.scrapbox;
    }
  }, {
    key: "ready",
    get: function get() {
      return util.scrapboxReady();
    }
  }, {
    key: "update",
    get: function get() {
      var _this = this;

      this.pageChange = this.pageChange || util.nodeChange(this.pageContainerElement, {
        childList: true,
        subtree: true
      });
      return rxjs.concat(this.ready, this.pageChange).pipe(operators.map(function () {
        return _this.data;
      }), operators.share());
    }
  }, {
    key: "pageContainerElement",
    get: function get() {
      return util.findElementOrFail('#app-container .page');
    }
  }, {
    key: "pageTitle",
    get: function get() {
      return this.data.Page.title || '';
    }
  }, {
    key: "pageLines",
    get: function get() {
      return this.data.Page.lines || [];
    }
  }, {
    key: "projectName",
    get: function get() {
      return this.data.Project.name;
    }
  }]);

  return UserScriptApi;
}();

_rollupPluginBabelHelpers.defineProperty(UserScriptApi, "pageChange", void 0);

exports.UserScriptApi = UserScriptApi;
//# sourceMappingURL=scrapbox.js.map
